const Precos = require("../infra/repository/precos.repository");
const precos = new Precos();

class precosController {
 


    register() {
        return function (req, res) {
            const  data  = req.body;

            precos.register(data).then((response) => {
                if (response.error) return res.status(response.code).send({ error: response.error });
                else return res.status(200).json(response);
            }).catch((error) => {
                return res.status(400).send({ error: `Não foi possível realizar o cadastro!` });
            });
        };
    }

   
 
     list() {
        return function (req, res) {
            const { id } = req.params;
            

            precos.list(id).then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    listPrecoPorUserId() {
        return function (req, res) {
            const id_user = req.query.id_user;
            

            precos.listPrecoPorUserId(id_user).then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

    listTabelaPrecoNome() {
        return function (req, res) {
            

            precos.listTabelaPrecoNome().then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

    listProdutosComPrecos() {
        return function (req, res) {
            const { id } = req.params;
            

            precos.listProdutosComPrecos().then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

    
    listTodosProdutosPorTabela() {
        return function (req, res) {
            const { id } = req.params;
            

            precos.listTodosProdutosPorTabela().then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

    


    listprecosByUser() {
        return function (req, res) {
            const id_user  = req.query.id_user;
            

            precos.listprecosByUser(id_user).then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

    listPrecosByUserTipo() {
        return function (req, res) {
            const id_user  = req.query.id_user;
            

            precos.listPrecosByUserTipo(id_user).then((response) => {
                if (response.error) res.status(response.code).send({ error: response.error });
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    delete() {
        return function (req, res) {
            const id = req.query.id;
            
            precos.delete(id).then((response) => {
                if (response.error) res.status(response.code).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    update() {
        return function (req, res) {
            const  data  = req.body;
            
            precos.update(data).then((response) => {
                if (response.error) res.status(400).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

    updateTabelaPreco() {
        return function (req, res) {
            const  data  = req.body;
            
            precos.updateTabelaPreco(data).then((response) => {
                if (response.error) res.status(400).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }


    updatePreco() {
        return function (req, res) {
            const data = req.body;
            
            precos.updatePreco(data).then((response) => {
                if (response.error) res.status(400).send(response);
                else return res.status(200).send(response);
            }).catch((error) => {
                throw new Error(error);
            });
        }
    }

}

module.exports = precosController;