const express = require("express");
const routes = express.Router();
const multer = require("multer");

const storage = multer.memoryStorage();


const upload = multer({ 
    storage,
    dest: "uploads/"
})
const auth = require("../config/auth/auth");


const VendedoresController = require("../controller/vendedores.controller")
const vendedoresController = new VendedoresController();

const ProdutosController = require("../controller/produtos.controller");
const produtosController = new ProdutosController();

routes.post("/login", vendedoresController.login())

// routes.post('/upload', upload.single('file'));


routes.post("/multer", upload.single("file"), vendedoresController.uploader())
routes.get("/multer", vendedoresController.getFileFromS3());



routes.get("/produtosVisiveis", produtosController.listProdutosVisiveis());

routes.post("/emailCliente", vendedoresController.emailToUser());
routes.get("/clientesDoVendedor", vendedoresController.listClientesDoVendedor());
routes.get("/topProdutos", vendedoresController.listTopProdutosVendedor());
routes.get("/topClientes", vendedoresController.listTopClientesVendedor());
routes.get("/vendasMensais", vendedoresController.listVendasMensais());
routes.get("/countAll", vendedoresController.listCountAllVendedorHTTP());
routes.get("/metaMensal", vendedoresController.listMetasMensalHTTP());
routes.get("/grafico", vendedoresController.listFormVendedorByPeriodo());
routes.patch("/produtos", vendedoresController.updateProduto());

routes.get("/relatorio", vendedoresController.listFormUsuarioProdutos());
routes.post("/registraUser", upload.single("file"), vendedoresController.registerUserPorVendedor());


routes.get("/userInfo", vendedoresController.listUser());
routes.patch("/edit", vendedoresController.edit());
routes.post("/userId", vendedoresController.loginUser());

routes.patch("/recover", vendedoresController.recover());

routes.get("/descontos", vendedoresController.listDescontosByUserVendedor());
routes.post("/descontos", vendedoresController.registerDesconto())








routes.get("/", vendedoresController.list())
routes.post("/", vendedoresController.register())
routes.patch("/", vendedoresController.update())
routes.delete("/:id", vendedoresController.delete())

routes.get("/qtdeTotalVendedoresContrato", vendedoresController.listQtdeTotalVendedoresContrato());





module.exports = routes;